#include "mbedconsole.h"
#include "clock.h"
#include "i2s.h"
#include "nvic.h"
 
 
PS2Keyboard *ps2kb;
DigitalOut myled(LED1);


Serial serial(USBTX, USBRX);
ConsoleStream console;

void keyboard_init();

int main() {
    //Set all priorities to 100 so we are able to make VGA a priority
    //By default, all priorities are at their highest 0
    NVIC_SetPriority( NonMaskableInt_IRQn, 100 ); 
    NVIC_SetPriority(MemoryManagement_IRQn, 100);
    
    NVIC_SetPriority(BusFault_IRQn, 100);
    NVIC_SetPriority(UsageFault_IRQn, 100);
    NVIC_SetPriority(SVCall_IRQn, 100);
    NVIC_SetPriority(DebugMonitor_IRQn, 100);
    NVIC_SetPriority(PendSV_IRQn, 100);
    NVIC_SetPriority(SysTick_IRQn, 100);
    NVIC_SetPriority(WDT_IRQn, 100);
    NVIC_SetPriority(TIMER0_IRQn, 100);
    NVIC_SetPriority(TIMER1_IRQn, 100);
    NVIC_SetPriority(TIMER2_IRQn, 100);
    NVIC_SetPriority(TIMER3_IRQn, 100);
    NVIC_SetPriority(UART0_IRQn, 100);
    NVIC_SetPriority(UART1_IRQn, 100);
    NVIC_SetPriority(UART2_IRQn, 100);
    NVIC_SetPriority(UART3_IRQn, 100);
    
    NVIC_SetPriority(PWM1_IRQn, 100);
    NVIC_SetPriority(I2C0_IRQn, 100);
    NVIC_SetPriority(I2C1_IRQn, 100);
    NVIC_SetPriority(I2C2_IRQn, 100);
    NVIC_SetPriority(SPI_IRQn, 100);
    NVIC_SetPriority(SSP0_IRQn, 100);
    NVIC_SetPriority(SSP1_IRQn, 100);
    NVIC_SetPriority(PLL0_IRQn, 100);
    NVIC_SetPriority(RTC_IRQn, 100);
    NVIC_SetPriority(EINT0_IRQn, 100);
    NVIC_SetPriority(EINT1_IRQn, 100);
    
    NVIC_SetPriority(EINT2_IRQn, 100);
    NVIC_SetPriority(EINT3_IRQn, 100);
    NVIC_SetPriority(ADC_IRQn, 100);
    NVIC_SetPriority(BOD_IRQn, 100);
    NVIC_SetPriority(USB_IRQn, 100);
    NVIC_SetPriority(CAN_IRQn, 100);
    NVIC_SetPriority(DMA_IRQn, 100);
    
    NVIC_SetPriority(I2S_IRQn, 100);
    NVIC_SetPriority(ENET_IRQn, 100);
    NVIC_SetPriority(RIT_IRQn, 100);
    NVIC_SetPriority(MCPWM_IRQn, 100);
    NVIC_SetPriority(QEI_IRQn, 100);
    NVIC_SetPriority(PLL1_IRQn, 100);
    init_vga();
    vga_cls();
    serial.baud(115200);
    serial.printf("Initializing PS/2..");
    keyboard_init();
    fl_select_clock_i2s(FL_CLOCK_DIV1); // assume 100MHz
    fl_i2s_set_tx_rate(1,4);            // set 25 MHz pixel clock 
    
    
    NVIC_SetPriority( EINT3_IRQn, 90 ); 
    serial.printf("Done\r\n");
    
    
    while(1)
    {
        vputs("mbedConsole by Jordan Earls\n");
        shell_begin();
    }
}
