#ifndef MBEDCONSOLE_H
#define MBEDCONSOLE_H

#include "mbed.h"
#include "vga640x480g.h"
#include "PS2Keyboard.h"

void vputc(char c);
void vputs(char *s);
char vgetc();
int vgetsl(char *s, int len);
void vsetcursor(int x, int y);

int strlcmp(const char *s1,const char *s2,size_t count);

void shell_begin();

extern PS2Keyboard *ps2kb;



extern Serial serial;


class ConsoleStream : public Stream //do this so we get printf and other goodies. Uses C functions for VGA and PS/2
{
    public:
    ConsoleStream(){}
    protected:
 
    // Stream implementation functions
    virtual int _putc(int value)
    {
        vputc((char)value);
        return 1;
    }
    virtual int _getc()
    {
        return vgetc();
    }
};

extern ConsoleStream console;


#endif